package com.bipt.intelligentapplicationorchestrationservice.service.Impl;

import com.bipt.intelligentapplicationorchestrationservice.mapper.DatasetMapper;
import com.bipt.intelligentapplicationorchestrationservice.pojo.DatasetDTO;
import com.bipt.intelligentapplicationorchestrationservice.pojo.DatasetEntity;
import com.bipt.intelligentapplicationorchestrationservice.service.DatasetService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.time.LocalDateTime;
import java.util.Map;

@Service
@Slf4j
public class DatasetServiceImpl implements DatasetService {
    @Autowired
    private DatasetMapper datasetMapper;

    /**
     * 新增数据集
     * @param datasetDTO
     */
    @Override
    public void save(DatasetDTO datasetDTO) {
        //判断数据集类型，如果是本地上传则保存，若用调用数据仓库进入下一步
        if (datasetDTO.getDatasetType()==0){
            //TODO 保存到分布式文件系统

        }else {
            Map<String,String> args = datasetDTO.getArgs();
            Integer datasetType = datasetDTO.getDatasetType();
            //TODO 根据筛选条件调用数据仓库中的数据

            //TODO 调用数据仓库保存到分布式文件系统
        }

    }

    /**
     * 修改数据集
     * @param datasetEntity
     */
    @Override
    @Transactional
    public void update(DatasetEntity datasetEntity) {
        if (datasetEntity.getDatasetType()==0){
            //TODO 覆盖保存到分布式文件系统中

        }else {

            //TODO 覆盖数据文件

            datasetEntity.setUpdateTime(LocalDateTime.now());
            //maybe需要判断
            datasetMapper.updata(datasetEntity);
        }
    }
}
